<?php
// utf-8 marker: äöüß
/**
 * Morepagedata
 * Backend
 * @author svasti
 */


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

define('MOREPAGEDATA_VERSION', '1 beta 3');

/**
 * Plugin administration
 */
if (isset($morepagedata)) {
    initvar('admin');
    initvar('action');


    $mpd_copyright = "<h2>Morepagedata_XH plugin\n"
                   . '<span style="font:normal normal 10pt sans-serif;">' . constant('MOREPAGEDATA_VERSION')
                   . ' &copy; 2013 by <a href="http://frankziesing.de/cmsimple/">svasti</a> &nbsp;'
                      // button to display copyright notice
                   . tag('input type="button" value="license?" style="font-size:80%;" OnClick="
                        if(document.getElementById(\'license\').style.display == \'none\') {
                            document.getElementById(\'license\').style.display = \'inline\';
                        } else {
                            document.getElementById(\'license\').style.display = \'none\';
                        }
                        "')
                   . '</span></h2>'."\n"
                   . '<p id="license" style="display:none;">'
                   . 'This plugin is free software under the terms of the GNU General Public License v. 3 or '
                   . 'later, analog to '.legallink(). tag('br'). tag('br')
                   . '<small><b>Acknowledgements:</b>'.tag('br')
                   . 'Code of <a href="http://jscolor.com/" target="_blank">JSColor</a> by Jan Odvárko (CZ),
                     and of json-functions for php4 by Christoph Becker <a href="http://3-magi.net/" target="_blank">(cmb)</a>'. tag('br')
                   . '</small></p>'."\n" ;


    $o .= print_plugin_admin('on');

    if (!$admin || $admin=='plugin_main') {

        // receiving and saving changes
        // ============================================================================
        if(isset($_POST['save_mpd']) || isset($_POST['mpd_import']) || isset($_POST['mpd_old']))  { 

            $newmpd['new']           =isset($_POST['mpd']['new'])     ? $_POST['mpd']['new']           : array();
            $newmpd['var']           =isset($_POST['mpd']['var'])     ? $_POST['mpd']['var']           : array();
            $newmpd['display']       =isset($_POST['mpd']['display']) ? $_POST['mpd']['display']       : array();
            $newmpd['type']          =isset($_POST['mpd']['type'])    ? $_POST['mpd']['type']          : array();
            $newmpd['add']           =isset($_POST['mpd']['add'])     ? $_POST['mpd']['add']           : array();
            $newmpd['up']            =isset($_POST['mpd']['up'])      ? $_POST['mpd']['up']            : array();
            $newmpd['delete']        =isset($_POST['mpd']['delete'])  ? $_POST['mpd']['delete']        : array();
            $newmpd['hr']            =isset($_POST['mpd']['hr'])      ? $_POST['mpd']['hr']            : array();
            $newmpd['options']       =isset($_POST['mpd']['options']) ? $_POST['mpd']['options']       : array();
            $newmpd['help']          =isset($_POST['mpd']['help'])    ? $_POST['mpd']['help']          : array();
            $newmpd['template']      =isset($_POST['mpd']['template'])? $_POST['mpd']['template']      : array();

            // load the old data for different purposes
            $mpd = json_decode(file_get_contents($pth['folder']['plugins'].'morepagedata/config/config2.php'),true);
            if($mpd==null)$mpd=array();

            // a little clean up
            foreach ($newmpd['var'] as $key=>$value) {
                $newmpd['var'][$key]        = preg_replace("/[^a-z_\-A-Z0-9]/", '', $value);
                $newmpd['hr'][$key]         = isset($newmpd['hr'][$key])? 1:0;
                if(!isset($newmpd['options'][$key]))  $newmpd['options'][$key] = '';
                if(!isset($newmpd['display'][$key]))  $newmpd['display'][$key] = '';
                if(!isset($newmpd['template'][$key])) $newmpd['template'][$key]= '';
                if(!isset($newmpd['help'][$key]))     $newmpd['help'][$key]    = '';
                $newmpd['options'][$key] = stsl($newmpd['options'][$key]);
                $newmpd['help'][$key]    = stsl($newmpd['help'][$key]);
                $newmpd['display'][$key] = stsl($newmpd['display'][$key]);

                // check if new variables are already in use by the system
                // select only new variables for the checking
                if(isset($newmpd['new'][$key])) {
                    // initializing
                    $refuse_var = 0;
                    // general check for collision with momentarily set variables
                    if(isset($$newmpd['var'][$key])) {$refuse_var ++;}
                    // check for collision with any pagedata variables
                    foreach ($pd_router->model->params as $pd_var) {
                    	if($pd_var == $newmpd['var'][$key]) {$refuse_var ++;}
                    }
                    // check for collision with other morepagedata variables
                    foreach ($mpd['var'] as $existing_var) {
                    	if($existing_var == $newmpd['var'][$key]) {$refuse_var ++;}
                    }
                    if($refuse_var) {
                        if($newmpd['var'][$key]) { //no notice if var is empty
                            $o .= '<p class="cmsimplecore_warning"><b>$'.$newmpd['var'][$key]
                               .  '</b> ' .$plugin_tx['morepagedata']['error_variable_already_used'].'</p>';
                        }
                        unset($newmpd['var'][$key],$newmpd['hr'][$key],$newmpd['options'][$key],$newmpd['help'][$key],$newmpd['display'][$key],$newmpd['type'][$key]);
                    }
                }
            }

            ksort($newmpd['hr']); // not really necessary, but makes it look nicer

            // DELETE
            //============
            $deletekey = array_search(TRUE, $newmpd['delete']);
            if($deletekey) {

                // first delete fields in pagedata.php
                $deletekey--;
                $attr = $newmpd['var'][$deletekey];
                $key = array_search($attr, $pd_router->model->params);
                if ($key !== FALSE) {unset($pd_router->model->params[$key]);}
                for ($i = 0; $i < count($pd_router->model->data); $i++) {
	               unset($pd_router->model->data[$i][$attr]);
                }
                unset($pd_router->model->temp_data[$attr]);
                $pd_router->model->save();

                // now delete fields in morepagedata arrays
                foreach ($newmpd as $key=>$value) {
                    unset($newmpd[$key][$deletekey]);
                }
            }

            // ADD
            //==========
            if(isset($newmpd['add'][0])) {
                foreach ($newmpd as $key=>$value) {
                    $newmpd[$key][] = '';
                }
            }

            // Move UP
            //===============
            $upkey = array_search(TRUE, $newmpd['up']);
            if($upkey > 0) {
                foreach ($newmpd as $key=>$value) {
                    // extract values
                    $moving_up = array_slice($newmpd[$key],$upkey,1);
                    // delete extracted values in the original array
                    array_splice($newmpd[$key],$upkey,1);
                    // add extracted value higher into the original array
                    array_splice($newmpd[$key],($upkey - 1),0,$moving_up);
                }
            }

            // clean the array of data which is not needed in the final file
            unset($newmpd['add'],$newmpd['new'],$newmpd['up'],$newmpd['delete']);

            // IMPORT + add to existing data
            //================================
            if(isset($_POST['mpd_import']) && !empty($mpd)) {
                // adding imported data to existing data
                foreach ($mpd as $key=>$value) {
                    foreach ($newmpd[$key] as $key2=>$value2) {
                    	$mpd[$key][] = $newmpd[$key][$key2];
                    }
                }
                $newmpd = $mpd;
            }

            // SAVE to file
            //==============
            file_put_contents($pth['folder']['plugins'] . 'morepagedata/config/config2.php',json_encode($newmpd));

        }
        // end of saving
        //============================================================================================================

        //read the stored data
        $raw_mpd = file_get_contents($pth['folder']['plugins'].'morepagedata/config/config2.php');
        $mpd = json_decode($raw_mpd,true);

        // Plugin main view
        $o .= $mpd_copyright;
        $o .= tag('br');
        $o .= '<form method="POST" action="">';

        // start table for entering config data
        //=====================================
        $o .= '<table class="mpd_configtable" cellpadding="1" cellspacing="3">'
           .  '<colgroup>'
           .  '<col width="">'
           .  '<col width="40%">'
           .  '<col width="25%">'
           .  '<col width="25%">'
           .  '<col width="">'
           .  '<col width="">'
          .  '</colgroup>'."\n";

        // headline
        //=========
        $o .= '<tr><td></td><th>'
           .  $plugin_tx['morepagedata']['field_display']
           .  '</th><th>'
           .  $plugin_tx['morepagedata']['field_var']
           .  '</th><th>'
           .  $plugin_tx['morepagedata']['field_type']
           .  '</th><th style="width:2em;text-align:left;">'
           .  'hr'
           .  '</th><td>'
           .  tag('input type="image" src="'.$pth['folder']['plugins'].$plugin
           .  '/images/add.png" style="width:16;height:16" name="mpd[add][0]" value="add" alt="Add entry"')
           .  '</td></tr>'."\n";


        // prepare option list for variable type
        foreach ($mpd['var'] as $key=>$value) {

            $mpd_type_select = '';
            foreach (array(
                'checkbox',
                'color_picker',
                'image_folder',
                'input_field',
                'option_list',
                'select_hiddenpage',
                'template_image',
                'textarea',
                'slide_show',
                'slide_effect',
                ) as $value) {

            	$selected = '';
            	if($mpd['type'][$key] == $value) {$selected = ' selected';}
            	$mpd_type_select .= "<option value='$value'$selected>$value</option>";
            }

            $mpd_hrchecked = $mpd['hr'][$key]? ' checked="checked"':'';

            // input data 1st row
            //===================
            $o .= '<tr>'."\n"

               .  '<td>'
               .  tag('input type="image" src="'.$pth['folder']['plugins'].$plugin
               .  '/images/up.gif" style="width:11px;height:16px;" value="true" name="mpd[up]['.$key.']"  alt="up"')
               .  '</td>'

               .  '<td>'
               .  tag('input type="text" style="width:96%;" value="'.$mpd['display'][$key].'" name="mpd[display]['.$key.']"')
               .  '</td>'
               .  '<td>';

            // make $mpd['var'] read only so that the pagedata.php doesn't get messed up
            $o .= $mpd['var'][$key]
                ? '<p class="mpd_variable">'.$mpd['var'][$key].'</p>'
                . tag('input type="hidden" value="'.$mpd['var'][$key].'" name="mpd[var]['.$key.']"')
                : tag('input type="text" value="'.$mpd['var'][$key].'" name="mpd[var]['.$key.']"')
                . tag('input type="hidden" value="true" name="mpd[new]['.$key.']"');
            $o .= '</td>'
               .  '<td><select name="mpd[type]['.$key.']" id="mpd_type['.$key
               .  ']" style="width:96%" OnChange="
                    if(this.options[this.selectedIndex].value == \'option_list\') {
                        document.getElementById(\'options['.$key.']\').style.display = \'table-row\';
                    } else {
                        document.getElementById(\'options['.$key.']\').style.display = \'none\';
                    }
                    if(this.options[this.selectedIndex].value == \'color_picker\' || this.options[this.selectedIndex].value == \'slide_show\') {
                        document.getElementById(\'help['.$key.']\').placeholder = \''.$plugin_tx['morepagedata']['placeholder_automatic_help'].'\';
                    } else {
                        document.getElementById(\'help['.$key.']\').placeholder = \''.$plugin_tx['morepagedata']['placeholder_help_field'].'\';
                    }
                    ; ">'.$mpd_type_select.'</select></td>'
               .  '<td>' . tag('input type="checkbox" value="1" '.$mpd_hrchecked.' style="text-align:center" name="mpd[hr]['.$key.']"') . '</td>'
               .  '<td>' . tag('input type="image" src="'.$pth['folder']['plugins'].$plugin
               .  '/images/delete.png" style="width:16;height:16" name="mpd[delete]['.($key + 1).']" value=TRUE alt="Delete entry"')
               .  '</td></tr>'."\n";

            $optionsline_visibility = ($mpd['type'][$key] == 'option_list' || $mpd['type'][$key] == 'input_field')
                        ? 'style="display:table-row"'
                        : 'style="display:none"';
            $helpline_visibility = 'style="display:table-row"'; //($mpd['help'][$key])
                        //? 'style="display:table-row"'
                        //: 'style="display:none"';
            $templateline_visibility = 'style="display:table-row"'; //($mpd['template'][$key])
                        //? 'style="display:table-row"'
                        //: 'style="display:none"';
            $placeholder = ($mpd['type'][$key] == 'color_picker' || $mpd['type'][$key] == 'slide_show')
                        ? $plugin_tx['morepagedata']['placeholder_automatic_help']
                        : $plugin_tx['morepagedata']['placeholder_help_field'];

            // input data 2nd row
            //===================
 			$o .= '<tr '.$optionsline_visibility.' id="options['.$key.']">' . "\n\t"
               .  '<td></td>'
               .  '<td colspan="4">' . "\n\t"
               .  tag('input type="text" style="width: 100%;" value="'.$mpd['options'][$key]
               .  '" name="mpd[options]['.$key.']" placeholder="'.$plugin_tx['morepagedata']['placeholder_option_list'].'"') . '</td>'
               .  '<td>&nbsp;</td>'
               .  '</tr>' . "\n";

            // input data 3nd row
            //===================
 			$o .= '<tr '.$helpline_visibility.' id="helpline['.$key.']">' . "\n\t"
               .  '<td></td>'
               .  '<td class="right_aligned">' . $plugin_tx['morepagedata']['field_help_text'] .': </td>'
               .  '<td colspan="3">' . "\n\t"
               .  tag('input type="text" style="width: 100%;" value="'.$mpd['help'][$key]
               .  '" name="mpd[help]['.$key.']" id="help['.$key.']" placeholder="'.$placeholder.'"') . '</td>'
               .  '<td>&nbsp;</td>'
               .  '</tr>' . "\n";

            // input data 4rd row
            //===================
 			$o .= '<tr '.$templateline_visibility.' id="templateline['.$key.']">' . "\n\t"
               .  '<td></td>'
               .  '<td class="right_aligned">' . $plugin_tx['morepagedata']['field_template'] .': </td>'
               .  '<td colspan="3">' . "\n\t"
               .  tag('input type="text" style="width: 100%;" value="'.$mpd['template'][$key]
               .  '" name="mpd[template]['.$key.']" id="mpd_template['.$key.']" placeholder="'
               .  $plugin_tx['morepagedata']['placeholder_template_list'].'"') . '</td>'
               .  '<td>&nbsp;</td>'
               .  '</tr>' . "\n";

            // empty line to separate value groups
 			$o .= '<tr><td colspan="5">&nbsp;</td></tr>' . "\n\t";

        }

        $o .= "\n".'</table>'
           .  "\n".'<div style="text-align: right;">'
           .  "\n".tag('input type="hidden" value="true" name="save_mpd"').tag('br')
           .  "\n".tag('input type="submit" value="'.ucfirst($tx['action']['save']).'"').tag('br')
           .  "\n".'</div>'
           .  "\n".'</form>'."\n";



        // New feature: importing morepagedata
        //=======================================
        // looking for morepagedata.csv in all template folders
        $handle = opendir($pth['folder']['templates']);
        $mpd_csv = array();
        while(false !== ($file = readdir($handle))) {
            if(is_dir($pth['folder']['templates'].$file) && strpos($file, '.') !== 0) {
                if(is_file($pth['folder']['templates'].$file.'/morepagedata.csv')) {

                    $mpd_csv = file($pth['folder']['templates'].$file.'/morepagedata.csv');
                    foreach($mpd_csv as $line_nr => $line_content) {
                        $line_content = trim(trim($line_content),';');
                        $value_pair_array = explode(';', $line_content);
                        foreach($value_pair_array as $key => $value) {
                            list($mpd_name,$mpd_value) = explode('=',$value,2);
                            $mpd_foundvar[$line_nr][trim($mpd_name)]=trim($mpd_value,' $');
                        }
                    }
                    //displaying the found data and making it importable
                    //=====================================================
                    $o .= tag('br').'<form method="POST" action="">';
                    $o .= '<table class="mpd_configtable" cellpadding="1" cellspacing="3">'
                       .  '<colgroup>'
                       .  '<col width="40%">'
                       .  '<col width="25%">'
                       .  '<col width="25%">'
                       .  '<col width="">'
                       .  '<col width="">'
                       .  '</colgroup>'."\n";

                    $o .= '<tr style="color:#070;"><th colspan="3">'.$plugin_tx['morepagedata']['found_mpd_in_template']
                       .': <span style="color:red">'.$file.'</span></td></tr>';
                    $o .= '<tr><th><small>'
                       .  $plugin_tx['morepagedata']['field_display']
                       .  '</small></th><th><small>'
                       .  $plugin_tx['morepagedata']['field_var']
                       .  '</small></th><th><small>'
                       .  $plugin_tx['morepagedata']['field_type']
                       .  '</small></th></tr>'."\n";
                    foreach ($mpd_foundvar as $key=>$value) {
                        $o .= '<tr>'
                           .  '<td>'.$value['display'].'</td>'
                           .  '<td>$'.$value['var'].'</td>'
                           .  '<td>'.$value['type'].'</td>'
                           .  '</tr>';
                        $o .= tag('input type="hidden" value="'.$file.'" name="mpd[template]['.$key.']"')
                           .  tag('input type="hidden" value="true" name="mpd[new]['.$key.']"')
                           .  tag('input type="hidden" value="'.$value['var'].'" name="mpd[var]['.$key.']"')
                           .  tag('input type="hidden" value="'.$value['display'].'" name="mpd[display]['.$key.']"')
                           .  tag('input type="hidden" value="'.$value['type'].'" name="mpd[type]['.$key.']"');
                        if(isset($value['extra'])) {
                            if($value['type']=='option_list') {
                                $o .= tag('input type="hidden" value="'.$value['extra'].'" name="mpd[options]['.$key.']"');
                            } else {
                                $o .= tag('input type="hidden" value="'.$value['extra'].'" name="mpd[help]['.$key.']"');
                            }

                        }
                    }

                    $o .= '<tr style="text-align:right;"><th colspan="3">'
                       .  tag('input type="hidden" name="mpd_import" value="true"')
                       .  tag('input type="submit" value=" &nbsp; '.$plugin_tx['morepagedata']['import_mpd_fields'].' &nbsp; "')
                       .  '</th></tr>';
                    $o .= '</table>'."\n".'</form>'."\n";
                }
            }
        }
        closedir($handle);

        // importing values of former version
        //========================================
        if(strpos($raw_mpd, '<?php')!==false) {
            include $pth['folder']['plugins'].'morepagedata/config/config2.php';
            $mpd_fields     = explode(';', $mpd_cf['fields']);
            $mpd_fieldtypes = explode(';', $mpd_cf['fieldtypes']);
            $mpd_fieldnames = explode(';', $mpd_cf['fieldnames']);
            $mpd_details    = explode(';', $mpd_cf['details']);
            $mpd_hr         = explode(';', $mpd_cf['hr']);

            //displaying found data of old version and making it importable
            //=====================================================
            $o .= tag('br').'<form method="POST" action="">';
            $o .= '<table class="mpd_configtable" cellpadding="1" cellspacing="3">'
               .  '<colgroup>'
               .  '<col width="40%">'
               .  '<col width="25%">'
               .  '<col width="25%">'
               .  '<col width="">'
               .  '<col width="">'
               .  '</colgroup>'."\n";

            $o .= '<tr style="color:#070;"><th colspan="3">'.$plugin_tx['morepagedata']['found_former_version_mpd']
               .': <span style="color:red">'.$file.'</span></td></tr>';
            $o .= '<tr><th><small>'
               .  $plugin_tx['morepagedata']['field_display']
               .  '</small></th><th><small>'
               .  $plugin_tx['morepagedata']['field_var']
               .  '</small></th><th><small>'
               .  $plugin_tx['morepagedata']['field_type']
               .  '</small></th></tr>'."\n";
            foreach ($mpd_fields as $key=>$value) {
                $o .= '<tr>'
                   .  '<td>'.$mpd_fieldnames[$key].'</td>'
                   .  '<td>$'.$mpd_fields[$key].'</td>'
                   .  '<td>'.$mpd_fieldtypes[$key].'</td>'
                   .  '</tr>';
                $o .= tag('input type="hidden" value="'.$mpd_fields[$key].'" name="mpd[var]['.$key.']"')
                   .  tag('input type="hidden" value="'.$mpd_fieldnames[$key].'" name="mpd[display]['.$key.']"')
                   .  tag('input type="hidden" value="'.$mpd_fieldtypes[$key].'" name="mpd[type]['.$key.']"')
                   .  tag('input type="hidden" value="'.$mpd_hr[$key].'" name="mpd[hr]['.$key.']"');

                if(isset($mpd_details[$key])) {
                    if($mpd_fieldtypes[$key]=='option_list') {
                        $o .= tag('input type="hidden" value="'.$mpd_details[$key].'" name="mpd[options]['.$key.']"');
                    } else {
                        $o .= tag('input type="hidden" value="'.$mpd_details[$key].'" name="mpd[help]['.$key.']"');
                    }
                }

            }

            $o .= '<tr style="text-align:right;"><th colspan="3">'
               .  tag('input type="hidden" name="mpd_old" value="true"')
               .  tag('input type="submit" value=" &nbsp; '.$plugin_tx['morepagedata']['import_mpd_fields'].' &nbsp; "')
               .  '</th></tr>';
            $o .= '</table>'."\n".'</form>'."\n";
        }


    } else {
        $o .= plugin_admin_common($action, $admin, $plugin);
    }
}

?>
